import java.net.*;
import java.io.*;

public abstract class FTPTransferHelper {
	public static void retrA(String commandArgs, FTPConnection parent) {
		FTPObject sendableObject = null;
		PrintWriter writer = null;
		BufferedReader dataStream = null;
		String line = null;

		dataStream = new BufferedReader(parent.getCurrentObject().getReaderFromObject(commandArgs));

		if (dataStream == null) {
			System.out.println("Error sending file in ASCII format for RETR, file not found, or object not in child list");
			return;
		}

		Socket listSocket = parent.getDataConnection();
		parent.output("150 Opening ASCII mode data connection for " + commandArgs);

		try {
			if (parent.getResumePosition() > 0) dataStream.skip(parent.getResumePosition());

			writer = new PrintWriter(listSocket.getOutputStream());

			line = dataStream.readLine();
			while (line != null) {
				if (line != null) {
					writer.println(line);
					writer.flush();
				}
				line = dataStream.readLine();
			}

	      writer.close();
		   listSocket.close();
	    	dataStream.close();
		} catch (Exception e) {
			System.out.println("Error sending file in ASCII format for RETR");
			System.out.println(e);
			return;
		}

		parent.output("226 ASCII transfer complete");
	}

	public static void retrI(String commandArgs, FTPConnection parent) {
		FTPObject sendableObject = null;
		BufferedOutputStream writer = null;
		BufferedInputStream dataStream = null;
		int byt = -1;

		dataStream = new BufferedInputStream(parent.getCurrentObject().getInputFromObject(commandArgs));

		if (dataStream == null) {
			System.out.println("Error sending file in BINARY format for RETR, file not found, or object not in child list");
			return;
		}

		Socket listSocket = parent.getDataConnection();
		parent.output("150 Opening BINARY mode data connection for " + commandArgs);

		try {
			if (parent.getResumePosition() > 0) dataStream.skip(parent.getResumePosition());
	
			writer = new BufferedOutputStream(listSocket.getOutputStream(), 1);

			byt = dataStream.read();
			while (byt >= 0) {
				if (byt >= 0) {
					writer.write(byt);
					writer.flush();
				}
				byt = dataStream.read();
			}

	      writer.close();
		   listSocket.close();
	    	dataStream.close();
		} catch (Exception e) {
			System.out.println("Error sending file in BINARY format for RETR");
			System.out.println(e);
			return;
		}

		parent.output("226 BINARY transfer complete");
	}
}
