import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;

public class ObjectSelectionWindow extends JDialog {
	private FTPObject pickedObject, root;
	private JFrame parent;

	private JTree objectTree;
	private DefaultTreeModel objectTreeModel;
	private ObjectTreeNode treeRoot;

	private JPanel buttonPanel;
	private JButton okButton, cancelButton;

	private boolean okClicked;

	public ObjectSelectionWindow(JFrame p, FTPObject r) {
		super(p, true);

		pickedObject = null;

		parent = p;
		root = r;

		System.out.println("[G] object selection window> Building root node");
		treeRoot = new ObjectTreeNode(root);

		objectTreeModel = new DefaultTreeModel(treeRoot);
		objectTree = new JTree(objectTreeModel);

		getContentPane().setLayout(new BoxLayout(getContentPane(), BoxLayout.Y_AXIS));

		buttonPanel = new JPanel();
		buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.X_AXIS));

		okButton = new JButton("Ok");
		cancelButton = new JButton("Cancel");

		buttonPanel.add(Box.createHorizontalGlue());
		buttonPanel.add(cancelButton);
		buttonPanel.add(okButton);

		getContentPane().add(new JScrollPane(objectTree));
		getContentPane().add(buttonPanel);

		okButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent event) {
					okClicked = true;
					hide();
				}
			});

		cancelButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent event) {
					okClicked = false;
					hide();
				}
			});

		objectTree.addTreeWillExpandListener(new TreeWillExpandListener() {
				public void treeWillCollapse(TreeExpansionEvent event) throws ExpandVetoException {
				}

				public void treeWillExpand(TreeExpansionEvent event) throws ExpandVetoException {
					int c;
					int[] carray;
					ObjectTreeNode wnode = (ObjectTreeNode)event.getPath().getLastPathComponent();

					if (wnode.loadChildList()) {
						carray = new int[wnode.childCount()];
						for(c=0;c<wnode.childCount();c++) {
							carray[c] = c;
						}
						objectTreeModel.nodesWereInserted(wnode, carray);
					}
				}
			});

		objectTree.getSelectionModel().addTreeSelectionListener(new TreeSelectionListener() {
				public void valueChanged(TreeSelectionEvent event) {
					ObjectTreeNode node;
					if (objectTree.getSelectionPath() != null) {
						node = (ObjectTreeNode)objectTree.getSelectionPath().getLastPathComponent();
						if (node.getUserObject() instanceof FTPObject) {
							pickedObject = (FTPObject)node.getUserObject();
						}
					}
				}
			});
	}

	public boolean showSelf() {
		okClicked = false;

		setTitle("Browsing...");
		pack();
		show();
		return true;
	}

	public boolean getOk() {
		return okClicked;
	}

	public FTPObject getPickedObject() {
		return pickedObject;
	}
}