import java.util.*;
import javax.swing.*;
import javax.swing.tree.*;

public class ObjectTreeNode extends DefaultMutableTreeNode {
	private FTPObject ftpvalue;
	private boolean childrenAdded = false;

	public ObjectTreeNode(FTPObject v) {
		super(v);

		ftpvalue = v;

		if (ftpvalue.isDirectory()) {
			children = new Vector();
			children.add(new DefaultMutableTreeNode("Loading..."));
		}

		if (ftpvalue.toString().equals("root")) {
			loadChildList();
		}
	}

	public void add(MutableTreeNode newChild) throws IllegalStateException {
		throw new IllegalStateException("The 'void add(MutableTreeNode)' method is not available for " + this);
	}

	public boolean loadChildList() {
		int c;

		if (!childrenAdded) {
			children.removeAllElements();
			for(c=0;c<ftpvalue.getChildren().size();c++) {
				children.add(new ObjectTreeNode((FTPObject)(ftpvalue.getChildren().elementAt(c))));
			}
			childrenAdded = true;
			return true;
		}

		return false;
	}

	public int childCount() {
		return children.size();
	}

	public boolean getAllowsChildren() {
		return ftpvalue.isDirectory();
	}

	public void removeAllChildren() {
		return;
	}
}
